--- gdb-5.2.1/gdb/proc-service.c	2003/02/19 14:51:23	1.1
+++ gdb-5.2.1/gdb/proc-service.c	2003/02/19 14:52:49	1.2
@@ -234,7 +234,7 @@
   inferior_ptid = BUILD_LWP (lwpid, ph->pid);
 
   target_fetch_registers (-1);
-  fill_gregset ((gdb_gregset_t *) gregset, -1);
+  fill_gregset ((gdb_gregset_t *) &gregset, -1);
 
   do_cleanups (old_chain);
   return PS_OK;
@@ -251,7 +251,7 @@
   inferior_ptid = BUILD_LWP (lwpid, ph->pid);
 
   /* FIXME: We should really make supply_gregset const-correct.  */
-  supply_gregset ((gdb_gregset_t *) gregset);
+  supply_gregset ((gdb_gregset_t *) &gregset);
   target_store_registers (-1);
 
   do_cleanups (old_chain);
--- gdb-5.2.1/gdb/thread-db.c	2003/02/19 14:51:23	1.1
+++ gdb-5.2.1/gdb/thread-db.c	2003/02/19 14:52:49	1.2
@@ -801,7 +801,7 @@
   /* Note that we must call supply_gregset after calling the thread_db
      routines because the thread_db routines call ps_lgetgregs and
      friends which clobber GDB's register cache.  */
-  supply_gregset ((gdb_gregset_t *) gregset);
+  supply_gregset ((gdb_gregset_t *) &gregset);
   supply_fpregset (&fpregset);
 }
 
@@ -834,7 +834,7 @@
       supply_register (regno, raw);
     }
 
-  fill_gregset ((gdb_gregset_t *) gregset, -1);
+  fill_gregset ((gdb_gregset_t *) &gregset, -1);
   fill_fpregset (&fpregset, -1);
 
   err = td_thr_setgregs_p (&th, gregset);