diff -urN rpm-3.0.5-ORIG/config.guess rpm-3.0.5/config.guess
--- rpm-3.0.5-ORIG/config.guess	Wed Jul 12 11:01:39 2000
+++ rpm-3.0.5/config.guess	Wed Dec  6 16:04:18 2000
@@ -668,6 +668,10 @@
 		echo "${UNAME_MACHINE}-unknown-linux-gnuaout"
 		exit 0
 		;;
+	  elf_s390)  
+		echo "${UNAME_MACHINE}-ibm-linux-gnu"           
+		exit 0 
+		;;
 	  elf32ppc)
 		# Determine Lib Version
 		cat >$dummy.c <<EOF
diff -urN rpm-3.0.5-ORIG/config.sub rpm-3.0.5/config.sub
--- rpm-3.0.5-ORIG/config.sub	Wed Jul 12 11:01:39 2000
+++ rpm-3.0.5/config.sub	Wed Dec  6 16:06:50 2000
@@ -189,6 +189,12 @@
 	i[34567]86)
 	  basic_machine=$basic_machine-pc
 	  ;;
+	s390 | s390-ibm)
+	  basic_machine=s390-ibm
+	  ;;
+	s390-redhat)
+	  basic_machine=s390-redhat
+	  ;;
 	# Object if more than one company name word.
 	*-*-*)
 		echo Invalid configuration \`$1\': machine \`$basic_machine\' not recognized 1>&2
@@ -859,6 +865,9 @@
 	c4x*)
 		basic_machine=c4x-none
 		os=-coff
+		;;
+	s390-*)
+		basic_machine=s390-ibm
 		;;
 	*)
 		echo Invalid configuration \`$1\': machine \`$basic_machine\' not recognized 1>&2
diff -urN rpm-3.0.5-ORIG/popt/config.guess rpm-3.0.5/popt/config.guess
--- rpm-3.0.5-ORIG/popt/config.guess	Wed Jul 12 11:01:29 2000
+++ rpm-3.0.5/popt/config.guess	Wed Dec  6 16:08:49 2000
@@ -668,6 +668,10 @@
 		echo "${UNAME_MACHINE}-unknown-linux-gnuaout"
 		exit 0
 		;;
+	  elf_s390)  
+		echo "${UNAME_MACHINE}-ibm-linux-gnu"           
+		exit 0 
+		;;
 	  elf32ppc)
 		# Determine Lib Version
 		cat >$dummy.c <<EOF
diff -urN rpm-3.0.5-ORIG/popt/config.sub rpm-3.0.5/popt/config.sub
--- rpm-3.0.5-ORIG/popt/config.sub	Wed Jul 12 11:01:29 2000
+++ rpm-3.0.5/popt/config.sub	Wed Dec  6 16:10:08 2000
@@ -189,6 +189,12 @@
 	i[34567]86)
 	  basic_machine=$basic_machine-pc
 	  ;;
+	s390 | s390-ibm)
+	  basic_machine=s390-ibm
+	  ;;
+	s390-redhat)
+	  basic_machine=s390-redhat
+	  ;;
 	# Object if more than one company name word.
 	*-*-*)
 		echo Invalid configuration \`$1\': machine \`$basic_machine\' not recognized 1>&2