diff -urN rpm-3.0.5-ORIG/Makefile.in rpm-3.0.5/Makefile.in
--- rpm-3.0.5-ORIG/Makefile.in	Sat Jul 22 11:59:48 2000
+++ rpm-3.0.5/Makefile.in	Thu Dec 28 21:42:58 2000
@@ -171,7 +171,7 @@
 
 # XXX libtool can/should generate dependent libs.
 # XXX solaris2.6 cannot use *.la with --all-static (downrev binutils/egcs?)
-myldadd =  	$(top_builddir)/build/.libs/librpmbuild.a 	$(top_builddir)/lib/.libs/librpm.a 	$(top_builddir)/popt/.libs/libpopt.a 	@INTLLIBS@ @LIBMISC@
+myldadd =  	$(top_builddir)/build/.libs/librpmbuild.a 	$(top_builddir)/lib/.libs/librpm.a 	$(top_builddir)/popt/.libs/libpopt.a 	@LIBMISC@
 
 
 LDFLAGS = @LDFLAGS_STATIC@ $(myldflags)
diff -urN rpm-3.0.5-ORIG/aclocal.m4 rpm-3.0.5/aclocal.m4
--- rpm-3.0.5-ORIG/aclocal.m4	Sat Jul 22 11:53:19 2000
+++ rpm-3.0.5/aclocal.m4	Thu Dec 28 21:42:58 2000
@@ -1,4 +1,5 @@
 dnl aclocal.m4 generated automatically by aclocal 1.4
+dnl Just a line to touch the file.
 
 dnl Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
diff -urN rpm-3.0.5-ORIG/configure.in rpm-3.0.5/configure.in
--- rpm-3.0.5-ORIG/configure.in	Sat Jul 22 11:37:12 2000
+++ rpm-3.0.5/configure.in	Thu Dec 28 21:42:58 2000
@@ -350,9 +350,9 @@
 dnl horrible *temporary* hack to make sure that if we found gettext() in
 dnl -lintl that we add -lintl *back* to $LIBS.
 dnl
-if test X$gt_cv_func_gettext_libintl = Xyes ; then
-    LIBS="-lintl $LIBS"
-fi
+dnl if test X$gt_cv_func_gettext_libintl = Xyes ; then
+dnl    LIBS="-lintl $LIBS"
+dnl fi
 
 dnl Checks for header files we can live without.
 AC_HEADER_STDC
diff -urN rpm-3.0.5-ORIG/configure rpm-3.0.5/configure
--- rpm-3.0.5-ORIG/configure	Sat Jul 22 11:53:24 2000
+++ rpm-3.0.5/configure	Thu Dec 28 21:42:58 2000
@@ -5409,7 +5409,6 @@
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   ac_save_LIBS="$LIBS"
-LIBS="-lintl  $LIBS"
 cat > conftest.$ac_ext <<EOF
 #line 5415 "configure"
 #include "confdefs.h"