diff -urN vnc_unixsrc.orig/Xvnc/config/cf/Imake.cf vnc_unixsrc/Xvnc/config/cf/Imake.cf
--- vnc_unixsrc.orig/Xvnc/config/cf/Imake.cf	Sat Jul 26 22:41:02 1997
+++ vnc_unixsrc/Xvnc/config/cf/Imake.cf	Tue Feb  1 14:41:17 2000
@@ -556,6 +556,10 @@
 #  define Mc68020Architecture
 #  undef mc68000
 # endif /* mc68000 */
+# ifdef __s390__
+#  define S390Architecture
+# endif /* s390 */
+#undef __s390__
 #endif /* linux */
 
 #if (defined(__Lynx__) || defined(Lynx)) && (defined(i386) || defined(__i386__) || defined(__x86__) || defined(__powerpc__) || defined(__sparc__) || defined(sparc))
diff -urN vnc_unixsrc.orig/Xvnc/config/cf/linux.cf vnc_unixsrc/Xvnc/config/cf/linux.cf
--- vnc_unixsrc.orig/Xvnc/config/cf/linux.cf	Mon May 11 12:38:06 1998
+++ vnc_unixsrc/Xvnc/config/cf/linux.cf	Tue Feb  1 14:41:25 2000
@@ -259,6 +259,13 @@
 #define ServerExtraDefines	-DGCCUSESGAS XFree86ServerDefines
 #endif /* Mc68020Architecture */
 
+#ifdef S390Architecture
+#define OptimizaedCDebugFlags	-O1
+#define LinuxMachineDefines	-D__s390__
+#define ServerOSDefines		XFree86ServerOSDefines -DDDXTIME -DPART_NET
+#define ServerExtraDefines	-DGCCUSESGAS XFree86ServerDefines
+#endif /* S390Architecture */
+
 /*================================================================
    BEGIN ORL VNC modification
    Always define _REENTRANT since we may use threaded libraries */
diff -urN vnc_unixsrc.orig/Xvnc/config/imake/imakemdep.h vnc_unixsrc/Xvnc/config/imake/imakemdep.h
--- vnc_unixsrc.orig/Xvnc/config/imake/imakemdep.h	Sat Jul 26 22:41:05 1997
+++ vnc_unixsrc/Xvnc/config/imake/imakemdep.h	Tue Feb  1 14:41:07 2000
@@ -459,6 +459,9 @@
 # ifdef __alpha
 	"-D__alpha",
 # endif
+#ifdef __s390__         /* Linux/390 */
+	"-D__s390__",
+#endif
 # ifdef __alpha__
 	"-D__alpha__",
 # endif